package org.syndicate_lang.actors.example.example2;

import org.syndicate_lang.actors.Actor;
import org.syndicate_lang.actors.Ref;

public class Forwarder implements IForwarder {
    private final Ref<IForwarder> _main;
    private final int _nRounds;
    private Ref<IForwarder> _peer = null;

    public Forwarder(Ref<IForwarder> main, int nRounds) {
        this._main = main;
        this._nRounds = nRounds;
    }

    @Override
    public void setPeer(Ref<IForwarder> peer) {
        this._peer = peer;
    }

    @Override
    public void handleMessage(Actor _ac, final int hopCount) {
        Ref<IForwarder> target = hopCount >= this._nRounds - 1 ? _main : _peer;
        target.async((f, ac) -> f.handleMessage(ac, hopCount + 1));
    }
}
